//=============================================================================
//  MuseScore
//  Linux Music Score Editor
//  $Id:$
//
//  Bombarde et Biniou Koz Tab plugin pour instruments de musique traditionnelle bretonne en Si Bemol(Patrick Sauger)
//
//  modifié à partir du travail de : 
//  Dean Karres, Dario Escobedo, Werner Schweer et autres
//  qui est une adaptation du travail de Werner Schweera (a very famous recorder_fingering
//  plugin using Blayne Chastain's "Tin Whistle Tab") 
//  
//  Ce programme est un programme libre, vous pouvez le redistribuer, et/ou le 
//  modifier en respectant les terms de la GNU General Public License version 2.
//
//  Ce programme est est distribue dans l'espoir d'etre utile sans aucun brevet ni
//  garantie, sans meme la garantie d'une valuer marchande, ou ayant une aptitude a 
//  un but particulier. Jetez un oeil à la GNU General Public License version 2 pour plus de détails.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//=============================================================================
//
// This is ECMAScript code (ECMA-262 aka "Java Script")
//
//
// J'ai re cree une table de conversion a partir du Tin Whistle Tab de Blayne Chastain
// et je l'ai adapte aux instruments en Si Bemol que sont le Biniou Koz et la Bombarde.
// La bombarde est un instrument transpositeur, la gamme s'écrit un octave en dessous du son reel.
// La bombarde que j'utilise ne possede qu'une cle pour jouer avec un biniou koz
// Pour jouer avec une cornemuse elle doit en posseder deux, encore du travail en perspective ...
//
// Pour modifier la grandeurs des tablatures, ajuster le "font = new QFont("BombardeTab", 60);"
//
var fingerings = new Array();
fingerings["57"] = "a";
fingerings["58"] = "b";
fingerings["60"] = "c";
fingerings["62"] = "d";
fingerings["63"] = "e";
fingerings["65"] = "f";
fingerings["67"] = "g";
fingerings["68"] = "h";
fingerings["69"] = "i";
fingerings["70"] = "j";
fingerings["72"] = "k";
fingerings["74"] = "l";
fingerings["75"] = "m";
fingerings["77"] = "n";
fingerings["79"] = "o";
fingerings["80"] = "p";


//---------------------------------------------------------
//    init
//    this function will be called on startup of mscore
//---------------------------------------------------------

function init() {
	// print("test script init");
}

//-------------------------------------------------------------------
//    run
//    this function will be called when activating the
//    plugin menu entry
//
//    global Variables:
//    pluginPath - contains the plugin path; file separator is "/"
//-------------------------------------------------------------------

function run() {
	// no score open (MuseScore 2.0+, can't happen earlier)
	if (typeof curScore === 'undefined')
		return;
      
	var cursor   = new Cursor(curScore);
	var font;
	var text;

	cursor.staff = 0;
	cursor.voice = 0;
	cursor.rewind();  // set cursor to first chord/rest

	font = new QFont("BombardeTab", 60);

	while (!cursor.eos()) {
		if (cursor.isChord()) {
			var pitch = cursor.chord().topNote().pitch;
			if (pitch >= 57 && pitch <= 80){ 
				text = new Text(curScore);
				text.text = fingerings[pitch];
				text.defaultFont = font;
				text.yOffset = 6;
				cursor.putStaffText(text);
			}
		}
		cursor.next();
	}
}

//---------------------------------------------------------
//    menu:  defines were the function will be placed
//		in the MuseScore menu structure
//---------------------------------------------------------

var mscorePlugin = {
	menu: 'Plugins.Bombarde Tablature',
	init: init,
	run:  run
};

mscorePlugin;

